clear all
close all
clc

%% 1.CARGAR FICHEROS

    ficheros_entrenamiento=['d00.dat';'d01.dat'; 'd02.dat'; 'd03.dat';'d04.dat';...
        'd05.dat';'d06.dat';'d07.dat';'d08.dat';'d09.dat';'d10.dat';'d11.dat';'d12.dat';...
        'd13.dat';'d14.dat';'d15.dat';'d16.dat';'d17.dat';'d18.dat';'d19.dat';...
        'd20.dat';'d21.dat'
        ];

    ficheros_test=['d00_te.dat';'d01_te.dat'; 'd02_te.dat'; 'd03_te.dat';'d04_te.dat';...
        'd05_te.dat';'d06_te.dat';'d07_te.dat';'d08_te.dat';'d09_te.dat';'d10_te.dat';'d11_te.dat';'d12_te.dat';...
        'd13_te.dat';'d14_te.dat';'d15_te.dat';'d16_te.dat';'d17_te.dat';'d18_te.dat';'d19_te.dat';...
        'd20_te.dat';'d21_te.dat'
        ];

    for a=1:22
        load(ficheros_entrenamiento(a,:));
        load(ficheros_test(a,:));  
    end   


%% 2.NORMALIZAR DATOS
    datos=[d01; d02; d03;d04;d05; d06; d07; d08; d09; d10; d11; d12;...
    d13; d14; d15; d16; d17; d18; d19;d20; d21; d00'; d01_te; d02_te; d03_te; d04_te;...
    d05_te; d06_te; d07_te; d08_te; d09_te; d10_te; d11_te; d12_te;...
    d13_te; d14_te; d15_te; d16_te; d17_te; d18_te; d19_te; d20_te; d21_te; d00_te 
    ]; 
    normalizados=zscore(datos);

    normalizados_entrenamiento=normalizados(1:10580,:);
    normalizados_test=normalizados(10581:end,:);

%% 3.ANALISIS DE COMPONENTES PRINCIPALES
    %%3.1 ANALISIS DE COMPONENTES PRINCIPALES EN FICHEROS ENTRENAMIENTO
    pca_entrenamiento=[];
    for a=0:21 %%Ficheros entrenamiento
        [coeff,score,latent] = pca(normalizados_entrenamiento((a*480+1):(a+1)*480,:));    
        for b=1:3;
            m=0.6+0.1*b;
            i=0; %numero de autovalores
            n=0; %peso de los autovalores
            while n < m
                i= i+1;
                n = n+(latent(i)/(sum(latent)));
            end
            pca_entrenamiento(a+1,b)=[i];
        end
    end
    
    %%3.2 ANALISIS DE COMPONENTES PRINCIPALES EN FICHEROS DE TEST
    pca_test=[];
    for a=0:21 %%Datos con fallo
        [coeff,score,latent] = pca(normalizados_test((a*960+161):(a+1)*960,:));    
        for b=1:3;
            m=0.6+0.1*b;
            i=0; %numero de autovalores
            n=0; %peso de los autovalores
            while n < m
                i= i+1;
                n = n+(latent(i)/(sum(latent)));
            end
            pca_test(a+1,b)=[i];
        end
    end
   
    %En las matrices pca_entrenamiento y pca_test se guardan para el nmero de PC conservadas i
    %para un 70%, 80% y 90% de la variabilidad de la informacin (columnas) 
    %para cada fallo (filas)
    %n -Porcentaje de la variabilidad en las componentes principales conservadas 
    %i -Numero de componentes principales
    
%% 4.SELECCIN DE VARIABLES
    %%4.1.SELECCIN DE VARIABLES EN FICHEROS DE ENTRENAMIENTO
    seleccion_variables_entrenamiento=[];
    for a=0:21
        [coeff,score,latent] = pca(normalizados_entrenamiento((a*480+1):(a+1)*480,:)); 
        sumacolumnas=sum(abs(coeff));
        total=sum(sumacolumnas');
        porcentajecolumnas=(sumacolumnas/total)*100;
        seleccion_variables_entrenamiento(:,a+1)=[porcentajecolumnas']        

    end

    %%4.2.SELECCIN DE VARIABLES EN FICHEROS TIPO DE TEST
    seleccion_variables_test=[];
    for a=0:21
        [coeff,score,latent] = pca(normalizados_test((a*960+161):(a+1)*960,:));
        sumacolumnas=sum(abs(coeff));
        total=sum(sumacolumnas');
        porcentajecolumnas=(sumacolumnas/total)*100;
        p=porcentajecolumnas';
        seleccion_variables_test(:,a+1)=[porcentajecolumnas'];
    end


%% 5.CRITERIO SELECCIN DE VARIABLES (OWA) (Para cada modo de funcionamiento particular)
    importancia_variables=[] %Importancia de las variables (filas) segn su modo de funcionamiento (Columnas)
    ranking_individual=[]

    %%Se busca el orden de cada una de las variables segn su peso
    posicion_entrenamiento=[]
    posicion_test=[]
    for a=0:21

        %Para ficheros entrenamiento
        orden=[(1:52)' seleccion_variables_entrenamiento(:,a+1)];
        [B1,k] = sort(orden(:,2), 'descend');
        B1 = [orden(k) B1];
        for b=1:52
            [i,j]=find(B1(:,1)==b);
            posicion_entrenamiento(b)=i;
        end

        %Para ficheros test
        orden=[(1:52)' seleccion_variables_test(:,a+1)];
        [B2,k] = sort(orden(:,2), 'descend');
        B2 = [orden(k) B2];
        for b=1:52
            [i,j]=find(B2(:,1)==b);
            posicion_test(b)=i;
        end



    % Aplicamos metodo owa

    andness = 0.4;
    orness = 1-andness;
    alpha = (1-orness)/orness;
    x = 0:0.0001:1;
    y= x.^alpha;

    numMetodosVotantes=2;
    pesos=[];
    for i=1:numMetodosVotantes
        pesoWi=(i/numMetodosVotantes)^alpha-((i-1)/numMetodosVotantes)^alpha;
        pesos=[pesos pesoWi];
    end

    pesos
    sum(pesos)

    rankVbles=[posicion_entrenamiento' posicion_test'];

    rankVblesOrdenado=sort(rankVbles','descend');
    rankVblesOrdenado=rankVblesOrdenado';
    rankVblesOrdenado;

    owaVbles=zeros(size(rankVbles,1),1);

    for j=1:size(rankVbles,1)
        for i=1:numMetodosVotantes
            owaVbles(j,1)=owaVbles(j,1)+rankVblesOrdenado(j,i)*pesos(i);
        end
    end
    owaVbles


    pesosVbles=[seleccion_variables_entrenamiento(:,a+1) seleccion_variables_test(:,a+1)];

    pesosVblesOrdenado=sort(pesosVbles','descend');
    pesosVblesOrdenado=pesosVblesOrdenado';
    pesosVblesOrdenado

    owaPesosVbles=zeros(size(pesosVbles,1),1);

    for j=1:size(pesosVbles,1)
        for i=1:numMetodosVotantes
            owaPesosVbles(j,1)=owaPesosVbles(j,1)+pesosVblesOrdenado(j,i)*pesos(i);
        end
    end


    owaPesosVbles



    %Nos da para cada caso de estudio (22 MODOS DE FUNCIONAMIENTO) y variable (nm de fila) su peso
    importancia_variables(:,a+1)=owaPesosVbles %Importancia de las variables (filas) segn su modo de funcionamiento



        ordenar=[(1:52)' importancia_variables(:,a+1)];
        [B3,k] = sort(ordenar(:,2), 'descend');
        ranking_individual(:,a+1)=k; %% Matriz que da el orden de las variables para cada modo de funcionamiento (columnas)
    end



%% 6.CRITERIO SELECCIN DE VARIABLES (OWA) (Ranking para modelos globales)


    ranking_global=[]
    %%Se busca el orden de cada una de las variables segn su peso
    posicion_entrenamiento=[]
    posicion_test=[]
    for a=0:21

        %Para ficheros entrenamiento
        orden=[(1:52)' seleccion_variables_entrenamiento(:,a+1)];
        [B1,k] = sort(orden(:,2), 'descend');
        B1 = [orden(k) B1];
        for b=1:52
            [i,j]=find(B1(:,1)==b)
            posicion_entrenamiento(b,a+1)=i %%Se almacenan en columnas los pesos de cada fichero
        end

        %Para ficheros test
        orden=[(1:52)' seleccion_variables_test(:,a+1)];
        [B2,k] = sort(orden(:,2), 'descend');
        B2 = [orden(k) B2];
        for b=1:52
            [i,j]=find(B2(:,1)==b);
            posicion_test(b,a+1)=i; %%Se almacenan en columnas los pesos de cada fichero
        end

    end

    % Aplicamos metodo owa

    andness = 0.4;
    orness = 1-andness;
    alpha = (1-orness)/orness;
    x = 0:0.0001:1;
    y= x.^alpha;

    numMetodosVotantes=42; 
    pesos=[];
    for i=1:numMetodosVotantes
        pesoWi=(i/numMetodosVotantes)^alpha-((i-1)/numMetodosVotantes)^alpha;
        pesos=[pesos pesoWi];
    end

    pesos
    sum(pesos)

    rankVbles=[posicion_entrenamiento posicion_test];

    rankVblesOrdenado=sort(rankVbles','descend');
    rankVblesOrdenado=rankVblesOrdenado';
    rankVblesOrdenado;

    owaVbles=zeros(size(rankVbles,1),1);

    for j=1:size(rankVbles,1)
        for i=1:numMetodosVotantes
            owaVbles(j,1)=owaVbles(j,1)+rankVblesOrdenado(j,i)*pesos(i);
        end
    end
    owaVbles;


    pesosVbles=[seleccion_variables_entrenamiento seleccion_variables_test];

    pesosVblesOrdenado=sort(pesosVbles','descend');
    pesosVblesOrdenado=pesosVblesOrdenado';
    pesosVblesOrdenado;

    owaPesosVbles=zeros(size(pesosVbles,1),1);

    for j=1:size(pesosVbles,1)
        for i=1:numMetodosVotantes
            owaPesosVbles(j,1)=owaPesosVbles(j,1)+pesosVblesOrdenado(j,i)*pesos(i);
        end
    end

    owaPesosVbles;

ordenar=[(1:52)' owaPesosVbles];
[B3,k] = sort(ordenar(:,2), 'descend');
ranking_global=k; %% Matriz que da el orden de las variables para cada modo de funcionamiento


%% 7.CREACIN DE MATRICES CON VARIABLES SELECCIONADAS

%% 7.1 INDIVIDUAL
    datos_individual=[]
    v=3 %%Numero de variables seleccionadas
    for caso=1:22 %El caso 22 es el 00
        for b=1:v 
            c=ranking_individual(b,caso);
            datos_individual((caso-1)*1280+1:1280*caso,b)=[normalizados_entrenamiento((480*(caso-1)+1):(480*caso),c); normalizados_test((960*(caso-1)+161):((960*caso)),c)];    
        end
    end   

    %En la matriz se guardan los datos correspondientes a las v variables
    %ms relevantes de cada fallo. Cada columna es una variable y los
    %fallos se ordenan en distintas filas.
%% 7.2 GLOBAL
    datos_entrenamiento_global=[]
    datos_test_global=[]
    v=3 %%Numero de variables seleccionadas
    for caso=1:22 %El caso 22 es el 00
        for b=1:v 
            c=ranking_global(b,1);
            datos_entrenamiento_global((caso-1)*480+1:480*caso,b)=[normalizados_entrenamiento((480*(caso-1)+1):(480*caso),c)];
            datos_test_global((caso-1)*800+1:800*caso,b)=[normalizados_test((960*(caso-1)+161):((960*caso)),c)];
        end
    end   
    
    targets_entrenamiento_global=(zeros(10560,1));
    targets_test_global=(zeros(17600,1));
    for caso=1:22 
        targets_entrenamiento_global((caso-1)*480+1:480*caso,1)=caso*1;
        targets_test_global((caso-1)*800+1:1)=1*caso;
    end  

    datostargets_entrenamiento_global=[datos_entrenamiento_global targets_entrenamiento_global];
    datostargets_test_global=[datos_test_global targets_test_global];
%% 9.MODELOS GLOBALES
%%% 9.1.ANFIS

    trnOpt(3)=0.01; %initial step size  
    trnOpt(4)=0.9; %step size decrease rate
    trnOpt(5)=1.1; %step size increase rate   
    dispOpt(1)=1;
    dispOpt(2)=1;
    dispOpt(3)=1;
    dispOpt(4)=1;
    optMethod=1;
    resultado_anfis_global=[];
    fila=1;
    for c=10:10:1000 %% training epoch number
        trnOpt(1)=c 
        trnOpt(2)=0.001 %% Error de entrenamiento
        for r=0.1:0.05:0.7
            R=[r r r r];
            initFis = genfis2(datos_entrenamiento_global,targets_entrenamiento_global,r);
            [FIS,ERROR,STEPSIZE,CHKFIS,CHKERROR] =  anfis(datostargets_entrenamiento_global,initFis,trnOpt,dispOpt,datostargets_test_global,optMethod)

            resultado_anfis_global(fila,1)=c
            resultado_anfis_global(fila,2)=r
            resultado_anfis_global(fila,3)=mse(ERROR)
            resultado_anfis_global(fila,4)=mse(CHKERROR)

            fila=fila+1
        end
    end    
    
%%% 9.2.RBF 
    resultado_rbf_global=[]
    fila=1  
    goal = 0.001;
    DF = 25;
    for spread=1:4; 
        for MN=10:10:500 
            net= newrb(datos_entrenamiento_global',targets_entrenamiento_global',goal,spread,MN,DF);
            resultado_rbf_global(fila,1)=spread;
            resultado_rbf_global(fila,2)=MN;
            resultado_rbf_global(fila,3)=mse(sim(net,datos_entrenamiento_global));
            resultado_rbf_global(fila,4)=mse(sim(net,datos_test_global));
            fila=fila+1
        end
    end
   
%%% 9.3.BPROPAGATION (GLOBAL)
    fila=1
    for a=5:20:500 %iteraciones de entrenamiento
        for n=10:10:5000
            net.trainParam.epochs=a

            net= newff(minmax(datos_entrenamiento_global'),[n,1],{'purelin','purelin','trainlm'});
            [net,tr] = train(net,datos_entrenamiento_global', targets_entrenamiento_global');

            resultado_bp_global(fila,1)=a;
            resultado_bp_global(fila,2)=n;
            resultado_bp_global(fila,3)=mse(sim(net,datos_entrenamiento_global')-targets_entrenamiento_global');  
            resultado_bp_global(fila,4)=mse(sim(net,datos_test_global')-targets_test_global');

            fila=fila+1

        end
    end          

%% 10.MODELOS PARCIALES
%%% 10.1.ANFIS

    trnOpt(3)=0.01; %initial step size  
    trnOpt(4)=0.9; %step size decrease rate
    trnOpt(5)=1.1; %step size increase rate   
    dispOpt(1)=1;
    dispOpt(2)=1;
    dispOpt(3)=1;
    dispOpt(4)=1;
    optMethod=1;
    resultado_anfis_individual=[];
    fila=1;

    casos=[1 2 3 4 5 7 8 9 10 11 12 13 14 15 16 17 19 20 21 22]
    for caso=casos
        datos_caso(1:1280,:)=datos_individual((caso-1)*1280+1:1280*caso,1:v)
        datos_entrenamiento_individual=datos_caso(1:480,:)
        datos_test_individual=datos_caso(481:end,:)
        targets_entrenamiento_individual=caso*ones(480,1);
        targets_test_individual=caso*ones(800,1);
        entrada=[datos_entrenamiento_individual targets_entrenamiento_individual];
        salida=[datos_test_individual targets_test_individual]
        if caso==1;
            r2=0.42    
        end
        if caso==2;
            r2=1    
        end
        if caso==3;
            r2=0.69    
        end
        if caso==4;
            r2=0.56    
        end
        if caso==5;
            r2=0.44    
        end
        if caso==7;
            r2=0.51    
        end
        if caso==8;
            r2=0.84    
        end
        if caso==9;
            r2=0.70    
        end
        if caso==10;
            r2=0.49    
        end
        if caso==11;
            r2=0.57    
        end
        if caso==12;
            r2=0.71    
        end
        if caso==13;
            r2=0.69    
        end
        if caso==14;
            r2=0.59   
        end
        if caso==15;
            r2=0.51    
        end
        if caso==16;
            r2=0.51    
        end
        if caso==17;
            r2=0.54    
        end
        if caso==19;
            r2=0.55    
        end
        if caso==20;
            r2=0.61   
        end
        if caso==21;
            r2=0.49   
        end
        if caso==22;
            r2=0.46    
        end
        % Parametros variables
        for c=10:10:1000 %% training epoch number
            trnOpt(1)=c; 
            trnOpt(2)=0.001; %% Error de entrenamiento
      
            for r=0.1:0.01:r2
                R=[r r r r];

                initFis = genfis2(datos_entrenamiento_individual,targets_entrenamiento_individual,r);
                [FIS,ERROR,STEPSIZE,CHKFIS,CHKERROR] =  anfis(entrada,initFis,trnOpt,dispOpt,salida,optMethod)

                resultado(fila,1)=caso;
                resultado(fila,2)=c;
                resultado(fila,3)=i;
                resultado(fila,4)=r;
                resultado(fila,5)=mse(ERROR)    
                resultado(fila,6)=mse(CHKERROR)

                fila=fila+1
                
            end
        end    
    end

%%%10.2.RBF

    resultado_rbf=[]
    fila=1
    for caso=1:22
        datos_caso(1:1280,:)=datos_individual((caso-1)*1280+1:1280*caso,1:v)
        datos_entrenamiento_individual=datos_caso(1:480,:)
        datos_test_individual=datos_caso(481:end,:)
        targets_entrenamiento_individual=caso*ones(480,1);
        targets_test_individual=caso*ones(800,1);    
        goal = 0.001; %Mean squared error goal
        DF = 25; %Number of neurons to add between displays, default = 25.
        for spread=1:4; %%TAMAO DE LA GRAGANTA (Default: 1)
        	for MN=10:10:100 %Nmero mximo de neuronas

            	net= newrb(datos_entrenamiento_individual',targets_entrenamiento_individual',goal,spread,MN,DF)

                resultado_rbf_individual(fila,1)=caso
                resultado_rbf_individual(fila,2)=i
                resultado_rbf_individual(fila,3)=spread
                resultado_rbf_individual(fila,4)=MN
                resultado_rbf_individual(fila,5)=mse(sim(net,datos_entrenamiento_individual)-caso) 
                resultado_rbf_individual(fila,6)=mse(sim(net,datos_test_individual)-caso)
                           
                fila=fila+1
            end
        end
    end

%%%10.3.BPROPAGATION

    fila=1
    DatosCaso=[]
    for caso=[22]
        datos_caso(1:1280,:)=datos_individual((caso-1)*1280+1:1280*caso,1:v);
        datos_entrenamiento_individual=datos_caso(1:480,:);
        datos_test_individual=datos_caso(481:end,:)
        targets_entrenamiento_individual=caso*ones(480,1);
        targets_test_individual=caso*ones(800,1);    
        for a=10:10:5000 %iteraciones de entrenamiento
            for n=5:10:500
               % net = feedforwardnet(1400);
                
                net= newff(minmax(datos_entrenamiento_individual'),[n,1],{'purelin','purelin','trainlm'});
                net.trainParam.epochs=a;
                [net,tr] = train(net,datos_entrenamiento_individual', targets_entrenamiento_individual');
                resultado_bp_individual(fila,1)=caso;
                resultado_bp_individual(fila,2)=a;
                resultado_bp_individual(fila,3)=n;
                resultado_bp_individual(fila,4)=mse(sim(net,datos_entrenamiento_individual')-targets_entrenamiento_individual');  
                resultado_bp_individual(fila,5)=mse(sim(net,datos_test_individual')-targets_test_individual');
                fila=fila+1
            end
        end          
    end
