clear all
close all
clc
%% 1.CARGAR FICHEROS
    ficheros_entrenamiento=['d00.dat';'d01.dat'; 'd02.dat'; 'd03.dat';'d04.dat';...
        'd05.dat';'d06.dat';'d07.dat';'d08.dat';'d09.dat';'d10.dat';'d11.dat';'d12.dat';...
        'd13.dat';'d14.dat';'d15.dat';'d16.dat';'d17.dat';'d18.dat';'d19.dat';...
        'd20.dat';'d21.dat'
        ];

    ficheros_test=['d00_te.dat';'d01_te.dat'; 'd02_te.dat'; 'd03_te.dat';'d04_te.dat';...
        'd05_te.dat';'d06_te.dat';'d07_te.dat';'d08_te.dat';'d09_te.dat';'d10_te.dat';'d11_te.dat';'d12_te.dat';...
        'd13_te.dat';'d14_te.dat';'d15_te.dat';'d16_te.dat';'d17_te.dat';'d18_te.dat';'d19_te.dat';...
        'd20_te.dat';'d21_te.dat'
        ];
    
    for a=1:22
        load(ficheros_entrenamiento(a,:));
        load(ficheros_test(a,:));  
    end   

%% 2.NORMALIZAR DATOS
    datos=[d01; d02; d03;d04;d05; d06; d07; d08; d09; d10; d11; d12;...
    d13; d14; d15; d16; d17; d18; d19;d20; d21; d00'; d01_te; d02_te; d03_te; d04_te;...
    d05_te; d06_te; d07_te; d08_te; d09_te; d10_te; d11_te; d12_te;...
    d13_te; d14_te; d15_te; d16_te; d17_te; d18_te; d19_te; d20_te; d21_te; d00_te 
    ]; 
    normalizados=zscore(datos);
    normalizados_entrenamiento=normalizados(1:10580,:);
    normalizados_test=normalizados(10581:end,:);

%% 3.ANALISIS DE COMPONENTES PRINCIPALES
    %%3.1 ANALISIS DE COMPONENTES PRINCIPALES EN FICHEROS ENTRENAMIENTO
    pca_entrenamiento=[];
    for a=0:21 %%Ficheros entrenamiento
        [coeff,score,latent] = pca(normalizados_entrenamiento((a*480+1):(a+1)*480,:));    
        for b=1:3;
            m=0.6+0.1*b;
            i=0; %numero de autovalores
            n=0; %peso de los autovalores
            while n < m
                i= i+1;
                n = n+(latent(i)/(sum(latent)));
            end
            pca_entrenamiento(a+1,b)=[i];
        end
    end
    
    %%3.2 ANALISIS DE COMPONENTES PRINCIPALES EN FICHEROS DE TEST
    pca_test=[];
    for a=0:21 %%Datos con fallo
        [coeff,score,latent] = pca(normalizados_test((a*960+161):(a+1)*960,:));    
        for b=1:3;
            m=0.6+0.1*b;
            i=0; %numero de autovalores
            n=0; %peso de los autovalores
            while n < m
                i= i+1;
                n = n+(latent(i)/(sum(latent)));
            end
            pca_test(a+1,b)=[i];
        end
    end
   
%% 4.SELECCIN DE VARIABLES
    %%4.1.SELECCIN DE VARIABLES EN FICHEROS DE ENTRENAMIENTO
    seleccion_variables_entrenamiento=[];
    for a=0:21
        [coeff,score,latent] = pca(normalizados_entrenamiento((a*480+1):(a+1)*480,:)); 
        sumacolumnas=sum(abs(coeff));
        total=sum(sumacolumnas');
        porcentajecolumnas=(sumacolumnas/total)*100;
        seleccion_variables_entrenamiento(:,a+1)=[porcentajecolumnas']        
    end

    %%4.2.SELECCIN DE VARIABLES EN FICHEROS TIPO DE TEST
    seleccion_variables_test=[];
    for a=0:21
        [coeff,score,latent] = pca(normalizados_test((a*960+161):(a+1)*960,:));
        sumacolumnas=sum(abs(coeff));
        total=sum(sumacolumnas');
        porcentajecolumnas=(sumacolumnas/total)*100;
        p=porcentajecolumnas';
        seleccion_variables_test(:,a+1)=[porcentajecolumnas'];
    end

%% 5.CRITERIO SELECCIN DE VARIABLES (OWA) (Para cada modo de funcionamiento particular)
    importancia_variables=[] %Importancia de las variables (filas) segn su modo de funcionamiento (Columnas)
    ranking_individual=[]

    %%Se busca el orden de cada una de las variables segn su peso
    posicion_entrenamiento=[]
    posicion_test=[]
    for a=0:21

        %Para ficheros entrenamiento
        orden=[(1:52)' seleccion_variables_entrenamiento(:,a+1)];
        [B1,k] = sort(orden(:,2), 'descend');
        B1 = [orden(k) B1];
        for b=1:52
            [i,j]=find(B1(:,1)==b);
            posicion_entrenamiento(b)=i;
        end

        %Para ficheros test
        orden=[(1:52)' seleccion_variables_test(:,a+1)];
        [B2,k] = sort(orden(:,2), 'descend');
        B2 = [orden(k) B2];
        for b=1:52
            [i,j]=find(B2(:,1)==b);
            posicion_test(b)=i;
        end
        
        % Aplicamos metodo owa

        andness = 0.4;
        orness = 1-andness;
        alpha = (1-orness)/orness;
        x = 0:0.0001:1;
        y= x.^alpha;

        numMetodosVotantes=2;
        pesos=[];
        for i=1:numMetodosVotantes
            pesoWi=(i/numMetodosVotantes)^alpha-((i-1)/numMetodosVotantes)^alpha;
            pesos=[pesos pesoWi];
        end

        pesos
        sum(pesos)

        rankVbles=[posicion_entrenamiento' posicion_test'];

        rankVblesOrdenado=sort(rankVbles','descend');
        rankVblesOrdenado=rankVblesOrdenado';
        rankVblesOrdenado;

        owaVbles=zeros(size(rankVbles,1),1);

        for j=1:size(rankVbles,1)
            for i=1:numMetodosVotantes
                owaVbles(j,1)=owaVbles(j,1)+rankVblesOrdenado(j,i)*pesos(i);
            end
        end
        owaVbles

        pesosVbles=[seleccion_variables_entrenamiento(:,a+1) seleccion_variables_test(:,a+1)];

        pesosVblesOrdenado=sort(pesosVbles','descend');
        pesosVblesOrdenado=pesosVblesOrdenado';
        pesosVblesOrdenado

        owaPesosVbles=zeros(size(pesosVbles,1),1);

        for j=1:size(pesosVbles,1)
            for i=1:numMetodosVotantes
                owaPesosVbles(j,1)=owaPesosVbles(j,1)+pesosVblesOrdenado(j,i)*pesos(i);
            end
        end


        owaPesosVbles

        %Nos da para cada caso de estudio (22 MODOS DE FUNCIONAMIENTO) y variable (nm de fila) su peso
        importancia_variables(:,a+1)=owaPesosVbles %Importancia de las variables (filas) segn su modo de funcionamiento

        ordenar=[(1:52)' importancia_variables(:,a+1)];
        [B3,k] = sort(ordenar(:,2), 'descend');
        ranking_individual(:,a+1)=k; %% Matriz que da el orden de las variables para cada modo de funcionamiento (columnas)
    end



%% 6. TASA XITO SISTEMA FINAL
    datos_individual=[]
    v=3 %%Numero de variables seleccionadas
    for caso=1:22 %El caso 22 es el 00
        for b=1:v 
            c=ranking_individual(b,caso);
            datos_individual((caso-1)*1280+1:1280*caso,b)=[normalizados_entrenamiento((480*(caso-1)+1):(480*caso),c); normalizados_test((960*(caso-1)+161):((960*caso)),c)];    
        end
    end
 
    goal = 0.001; %Mean squared error goal
    DF = 25; %Number of neurons to add between displays, default = 25.
    MN=10 %%Es vlido para todos
    exito=0
    fracaso=0
    for caso=1:22
        datos_caso(1:1280,:)=datos_individual((caso-1)*1280+1:1280*caso,1:v);
        %%datos_entrenamiento_individual=datos_caso(1:480,:)
        datos_test_individual=datos_caso(481:end,:);
        %%targets_entrenamiento_individual=caso*ones(480,1);
        targets_test_individual=caso*ones(800,1);
        k=1000 %Inicializar con un valor alto
        for i=1:800
            for modelo=1:22
                datos_modelo(1:1280,:)=datos_individual((modelo-1)*1280+1:1280*modelo,1:v);
                datos_entrenamiento_individual=datos_modelo(1:480,:);
                targets_entrenamiento_individual=modelo*ones(480,1);
                
                dato_test=datos_test_individual(i,:);
                target_test=targets_test_individual(i,:);
                if modelo==1
                    spread=1; 
                end
                if modelo==2
                    spread=3;  
                end
                if modelo==3
                    spread=4;  
                end
                if modelo==4
                    spread=4;  
                end
                if modelo==5
                    spread=1;  
                end
                if modelo==6
                    spread=1;  
                end
                if modelo==7
                    spread=1;  
                end
                if modelo==8
                    spread=4;  
                end
                if modelo==9
                    spread=3;  
                end
                if modelo==10
                    spread=1;   
                end
                if modelo==11
                    spread=4;  
                end
                if modelo==12
                    spread=2;   
                end
                if modelo==13
                    spread=1;  
                end
                if modelo==14
                    spread=1;  
                end
                if modelo==15
                    spread=1;  
                end
                if modelo==16
                    spread=4;  
                end
                if modelo==17
                    spread=4;  
                end
                if modelo==18
                    spread=1;  
                end
                if modelo==19
                    spread=4;   
                end
                if modelo==20
                    spread=1;   
                end
                if modelo==21
                    spread=1;   
                end
                if modelo==22
                    spread=3;   
                end
                net= newrb(datos_entrenamiento_individual',targets_entrenamiento_individual',goal,spread,MN,DF);         
                error=mse(sim(net,dato_test)-target_test);
                if(error<k)
                    k=error;
                    modelo_error_minimo=modelo;
                end    
            end
            if(caso==modelo_error_minimo)
                exito=exito+1
            else 
                fracaso=fracaso+1
            end
        end
    end     
